"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addPackageJsonToGit = void 0;
const fs_1 = __importDefault(require("fs"));
const promises_1 = require("fs/promises");
const isomorphic_git_1 = require("isomorphic-git");
const path_1 = require("path");
const addPackageJsonToGit = (targetDir) => __awaiter(void 0, void 0, void 0, function* () {
    const files = ["package.json", "package-lock.json", "yarn.lock", "pnpm-lock.yaml", "npm-shrinkwrap.json"];
    const filePathPromises = files
        .map(file => (0, path_1.resolve)(targetDir, file))
        .map((path) => __awaiter(void 0, void 0, void 0, function* () {
        return ({
            path,
            exists: yield (0, promises_1.access)(path)
                .then(() => true)
                .catch(() => false),
        });
    }));
    const filePaths = (yield Promise.all(filePathPromises)).filter(({ exists }) => exists).map(({ path }) => path);
    yield Promise.all(filePaths.map((filePath) => __awaiter(void 0, void 0, void 0, function* () { return yield (0, isomorphic_git_1.add)({ fs: fs_1.default, dir: targetDir, filepath: (0, path_1.relative)(targetDir, filePath) }); })));
});
exports.addPackageJsonToGit = addPackageJsonToGit;
