"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addToIgnoreFile = void 0;
const addToIgnoreFile = (fileContent, topic, entry) => __awaiter(void 0, void 0, void 0, function* () {
    const entries = typeof entry === "string" ? [entry] : entry;
    const lines = fileContent ? fileContent.split("\n") : [];
    const newEntries = entries.filter(entry => !lines.find(line => line.trim() === entry));
    // Entries already exists
    if (newEntries.length === 0) {
        return fileContent;
    }
    const topicStartIndex = lines.findIndex(line => line.trim() === `# ${topic}`);
    // New topic
    if (topicStartIndex === -1) {
        return lines.concat([`# ${topic}`, ...newEntries]).join("\n");
    }
    const topicLength = lines.slice(topicStartIndex + 1).findIndex(line => line.trim().startsWith(`# `));
    const topicLines = lines.slice(topicStartIndex + 1, topicLength === -1 ? undefined : topicLength + topicStartIndex + 1);
    const emptyLinesAfterLastEntry = topicLines.reduceRight((acc, line) => acc.foundEntry
        ? acc
        : line.trim() === "" || line.startsWith("#")
            ? Object.assign(Object.assign({}, acc), { emptyLines: acc.emptyLines + 1 }) : Object.assign(Object.assign({}, acc), { foundEntry: true }), { emptyLines: 0, foundEntry: false });
    const newEntryPosition = topicStartIndex + topicLines.length - emptyLinesAfterLastEntry.emptyLines;
    const newLines = lines.flatMap((line, index) => (index === newEntryPosition ? [line, ...newEntries] : [line]));
    return newLines.join("\n");
});
exports.addToIgnoreFile = addToIgnoreFile;
