"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.commitWithAuthor = void 0;
const fs_1 = __importDefault(require("fs"));
const isomorphic_git_1 = require("isomorphic-git");
const commitWithAuthor = (targetDir, message) => __awaiter(void 0, void 0, void 0, function* () {
    return yield (0, isomorphic_git_1.commit)({
        fs: fs_1.default,
        dir: targetDir,
        message: message,
        author: { name: "Zebreus", email: "lennart@madmanfred.com" },
        committer: { name: "Zebreus", email: "lennart@madmanfred.com" },
    });
});
exports.commitWithAuthor = commitWithAuthor;
