"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.prepareTargetDir = void 0;
const promises_1 = require("fs/promises");
const prepareTargetDir = (targetDir) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        yield (0, promises_1.access)(targetDir);
    }
    catch (e) {
        yield (0, promises_1.mkdir)(targetDir, { recursive: true });
    }
    const targetDirStat = yield (0, promises_1.stat)(targetDir);
    if (!targetDirStat.isDirectory()) {
        throw new Error(`Target directory ${targetDir} is not a directory`);
    }
    const packageJsonAlreadyExists = yield (0, promises_1.access)(targetDir + "/package.json")
        .then(() => true)
        .catch(() => false);
    if (packageJsonAlreadyExists) {
        throw new Error(`Target directory ${targetDir} already contains a package.json`);
    }
});
exports.prepareTargetDir = prepareTargetDir;
