"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeAndAddFile = void 0;
const fs_1 = __importDefault(require("fs"));
const promises_1 = require("fs/promises");
const isomorphic_git_1 = require("isomorphic-git");
const path_1 = require("path");
const writeAndAddFile = (targetDir, file, content) => __awaiter(void 0, void 0, void 0, function* () {
    const targetFile = (0, path_1.resolve)(targetDir, file);
    const dir = (0, path_1.dirname)(targetFile);
    const dirExists = yield (0, promises_1.access)(dir)
        .then(() => true)
        .catch(() => false);
    if (!dirExists) {
        yield (0, promises_1.mkdir)(dir, { recursive: true });
    }
    yield (0, promises_1.writeFile)(targetFile, content);
    yield (0, isomorphic_git_1.add)({ fs: fs_1.default, dir: targetDir, filepath: (0, path_1.relative)(targetDir, targetFile) });
});
exports.writeAndAddFile = writeAndAddFile;
