"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTypescriptThing = void 0;
const ensureGitRepo_1 = require("./helpers/ensureGitRepo");
const prepareTargetDir_1 = require("./helpers/prepareTargetDir");
const path_1 = require("path");
const addNixShell_1 = require("./steps/addNixShell");
const addPrettier_1 = require("./steps/addPrettier");
const addTypescript_1 = require("./steps/addTypescript");
const initializeProject_1 = require("./steps/initializeProject");
const createTypescriptThing = ({ path, name, description, 
//   type,
//   monorepo = false,
repo, branch = "main", authorName, authorEmail, }) => __awaiter(void 0, void 0, void 0, function* () {
    const targetDir = (0, path_1.normalize)((0, path_1.resolve)(process.cwd(), path || name || "."));
    yield (0, prepareTargetDir_1.prepareTargetDir)(targetDir);
    yield (0, ensureGitRepo_1.ensureGitRepo)(targetDir, repo, branch);
    yield (0, addNixShell_1.addNixShell)(targetDir);
    yield (0, initializeProject_1.initializeProject)(targetDir, name, "0.0.0", description, authorName, authorEmail, "MIT");
    yield (0, addTypescript_1.addTypescript)(targetDir);
    yield (0, addPrettier_1.addPrettier)(targetDir);
});
exports.createTypescriptThing = createTypescriptThing;
exports.default = exports.createTypescriptThing;
