"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sh = void 0;
const child_process_1 = require("child_process");
const sh = (cmd) => __awaiter(void 0, void 0, void 0, function* () {
    return new Promise(function (resolve, reject) {
        (0, child_process_1.exec)(cmd, (err, stdout, stderr) => {
            if (err) {
                const error = new Error("Failed to create package");
                err.stack = undefined;
                //@ts-expect-error: we're adding a property to the error
                error.details = Object.assign(Object.assign({}, err), { stderr, stdout });
                error.stack = undefined;
                reject(error);
            }
            else {
                resolve({ stdout, stderr });
            }
        });
    });
});
exports.sh = sh;
