"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addNixShell = void 0;
const commitWithAuthor_1 = require("../helpers/commitWithAuthor");
const loadResource_1 = require("../helpers/loadResource");
const writeAndAddFile_1 = require("../helpers/writeAndAddFile");
const addNixShell = (targetDir) => __awaiter(void 0, void 0, void 0, function* () {
    const shellNixContent = yield (0, loadResource_1.loadResource)("shell.nix");
    yield (0, writeAndAddFile_1.writeAndAddFile)(targetDir, "shell.nix", shellNixContent);
    yield (0, commitWithAuthor_1.commitWithAuthor)(targetDir, "Add nix shell");
});
exports.addNixShell = addNixShell;
