"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addPrettier = void 0;
const addPackageJsonToGit_1 = require("../helpers/addPackageJsonToGit");
const addScriptToPackage_1 = require("../helpers/addScriptToPackage");
const commitWithAuthor_1 = require("../helpers/commitWithAuthor");
const writeAndAddFile_1 = require("../helpers/writeAndAddFile");
const install_pnpm_package_1 = require("install-pnpm-package");
const addPrettier = (targetDir) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, install_pnpm_package_1.installPackagePnpm)(["prettier", "prettier-plugin-organize-imports"], { directory: targetDir, type: "dev" });
    yield (0, addPackageJsonToGit_1.addPackageJsonToGit)(targetDir);
    const prettierRcObject = {
        arrowParens: "avoid",
        bracketSpacing: true,
        embeddedLanguageFormatting: "auto",
        htmlWhitespaceSensitivity: "css",
        insertPragma: false,
        jsxBracketSameLine: false,
        jsxSingleQuote: false,
        printWidth: 120,
        proseWrap: "always",
        quoteProps: "consistent",
        requirePragma: false,
        semi: false,
        singleQuote: false,
        tabWidth: 2,
        trailingComma: "es5",
        useTabs: false,
        vueIndentScriptAndStyle: false,
        plugins: ["prettier-plugin-organize-imports"],
    };
    yield (0, writeAndAddFile_1.writeAndAddFile)(targetDir, ".prettierrc.json", JSON.stringify(prettierRcObject, null, 2));
    yield (0, addScriptToPackage_1.addScriptToPackage)(targetDir, "format", "prettier --write .");
    yield (0, commitWithAuthor_1.commitWithAuthor)(targetDir, "Install prettier");
});
exports.addPrettier = addPrettier;
