"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addTypescript = void 0;
const addPackageJsonToGit_1 = require("../helpers/addPackageJsonToGit");
const addToGitIgnore_1 = require("../helpers/addToGitIgnore");
const commitWithAuthor_1 = require("../helpers/commitWithAuthor");
const writeAndAddFile_1 = require("../helpers/writeAndAddFile");
const install_pnpm_package_1 = require("install-pnpm-package");
const addTypescript = (targetDir) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, install_pnpm_package_1.installPackagePnpm)(["typescript", "@types/node"], { directory: targetDir, type: "dev" });
    yield (0, addPackageJsonToGit_1.addPackageJsonToGit)(targetDir);
    const tsConfigObject = {
        compilerOptions: {
            target: "es2016",
            lib: ["es2016", "esnext"],
            jsx: "preserve",
            module: "commonjs",
            allowJs: true,
            declaration: true,
            declarationMap: true,
            sourceMap: true,
            outDir: "dist",
            noEmit: true,
            isolatedModules: true,
            allowSyntheticDefaultImports: true,
            esModuleInterop: true,
            forceConsistentCasingInFileNames: true,
            strict: true,
            skipLibCheck: true,
            rootDir: "src",
            baseUrl: ".",
            paths: {
                "*": ["./src/*"],
            },
        },
        include: ["src/**/*"],
    };
    yield (0, writeAndAddFile_1.writeAndAddFile)(targetDir, "tsconfig.json", JSON.stringify(tsConfigObject, null, 2));
    yield (0, addToGitIgnore_1.addToGitIgnore)(targetDir, "typescript", ["*.tsbuildinfo", "dist/"]);
    yield (0, commitWithAuthor_1.commitWithAuthor)(targetDir, "Install typescript");
});
exports.addTypescript = addTypescript;
